<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
 "http://www.w3.org/TR/html4/loose.dtd">

<jsp:useBean id="JSONRPCBridge" scope="session"
     class="com.metaparadigm.jsonrpc.JSONRPCBridge" />
<% JSONRPCBridge.registerObject("hello", new com.snail.web.json.HelloJSON() ); %>

<html>
<head>

<title>JSON-RPC-Java Hello</title>
<script type="text/javascript" src="jsonrpc.js"></script>
<script language="javascript">
<!--
function init(){
  jsonrpc = new JSONRpcClient("JSON-RPC");
}

function clickHello(){
  var whoNode = document.getElementById("who");
  var result = jsonrpc.hello.sayHello(whoNode.value);
  alert("The server replied: " + result);
}

function clickErrMsg(){
  try{
    jsonrpc.hello.sayErrId();
  }catch(e){
    document.getElementById("eName").innerHTML=e.name;
    document.getElementById("eCode").innerHTML=e.code;
    document.getElementById("eMsg").innerHTML=e.message;
    document.getElementById("eStack").innerHTML=e.javaStack;
  }
}

function clickGetMap(){
    var ret = jsonrpc.hello.sayMap();
    document.getElementById("jsonMsg").innerHTML=toJSON(ret);
    document.getElementById("javaClass").innerHTML=ret.javaClass;
    document.getElementById("obj").innerHTML=
      "FirstElement= " + ret.map.FirstElement  + ", " +
      "SecondElement=" + ret.map.SecondElement + ", " +
      "ThirdElement= " + ret.map.ThirdElement  + ", " +
      "ForuthElement=" + ret.map.FourthElement;
}

function clickGetBean(){
    var ret = jsonrpc.hello.sayBean();
    document.getElementById("jsonMsg").innerHTML=toJSON(ret);
    document.getElementById("javaClass").innerHTML=ret.javaClass;
    document.getElementById("obj").innerHTML=
     "Name = "  + ret.name + ", " +
     "Age ="    + ret.age  + ", " +
     "Father= " + ret.father.name  + ", " +
     "Mother="  + ret.mother.name;
}

function clickGetList(){
    var ret = jsonrpc.hello.sayList();
    document.getElementById("jsonMsg").innerHTML=toJSON(ret);
    document.getElementById("javaClass").innerHTML=ret.javaClass;
    
    var str = "";
    for( cnt = 0 ; cnt < ret.list.length ; cnt++ ){
      str = str + cnt + " " + ret.list[ cnt ] + ", ";
    }
    document.getElementById("obj").innerHTML=str;
}

function clickSendMap(){
  try{
	var age    = document.getElementById("age").value;
	var name   = document.getElementById("name").value;
	var father = document.getElementById("father").value;
	var mother = document.getElementById("mother").value;
	
	var jsonMsg = 
	  {"javaClass" : "java.util.HashMap",
	   "map": {"Age": age, "Name": name, "Father": father, "Mother": mother} 
	  };
	
	alert( jsonrpc.hello.setMap(jsonMsg) );
  }catch(e){
    alert(e);
  }
}

function clickSendBean(){
  try{
	var age    = document.getElementById("age").value;
	var name   = document.getElementById("name").value;
	var father = document.getElementById("father").value;
	var mother = document.getElementById("mother").value;

	var jsonMsg = 
      {"javaClass": "com.snail.web.json.ExampleBean",
       "age": age, 
       "name": name,       
       "father": 
         {"javaClass": "com.snail.web.json.ExampleBean",
          "name": father},
       "mother": 
         {"javaClass": "com.snail.web.json.ExampleBean",
          "name": mother}
      };

	alert( jsonrpc.hello.setBean(jsonMsg) );
  }catch(e){
    alert(e);
  }
}

function clickSendList(){
  try{
	var age    = document.getElementById("age").value;
	var name   = document.getElementById("name").value;
	var father = document.getElementById("father").value;
	var mother = document.getElementById("mother").value;

	var jsonMsg = 
      {"javaClass": "java.util.LinkedList",
       "list": [age,name,father,mother] };

	alert( jsonrpc.hello.setList(jsonMsg) );
  }catch(e){
    alert(e);
  }
}
//-->
</script>

</head>
<body bgcolor="#ffffff" onLoad="init();">

<h2>JSON-RPC-Java Examinations</h2>

<hr/>

Hello JSON World!
<p>
 <strong>Who:</strong>
 <input type="text" id="who" size="30" value="Michael" />
 <input type="button" value="Say Hello" onclick="clickHello()" />
</p>

<hr/>

<table border="0" cellpadding="10px"><tr><td>

Argument Value Handling.
<p>
  <input type="button" value="Send Map" onclick="clickSendMap()" />
  <input type="button" value="Send Bean" onclick="clickSendBean()" />
  <input type="button" value="Send List" onclick="clickSendList()" />
  <fieldset>
    <legend>Argument Values</legend>
    <div style="height:9em;overflow:auto">
      <table border="0">
        <tr>
          <td>Age</td>
          <td><input type="text" id="age" size="30" value="5" /></td>
        </tr>
        <tr>
          <td>Name</td>
          <td><input type="text" id="name" size="30" value="Kent" /></td>
        </tr>
        <tr>
          <td>Father</td>
          <td><input type="text" id="father" size="30" value="Bob" /></td>
        </tr>
        <tr>
          <td>Mother</td>
          <td><input type="text" id="mother" size="30" value="Alice" /></td>
        </tr>
      </table>
    </div>
  </fieldset>
</p>

</td><td width="640px">

Return Value Handling.
<p>
  <input type="button" value="Get Map" onclick="clickGetMap()" />
  <input type="button" value="Get Bean" onclick="clickGetBean()" />
  <input type="button" value="Get List" onclick="clickGetList()" />
  <fieldset>
    <legend>Return Value Details</legend>
    <div style="height:9em;overflow:auto">
      <table border="0">
        <tr>
          <td valign="top" nowrap>JSON Msg</td>
          <td><div id="jsonMsg"></div></td>
        </tr>
        <tr>
          <td valign="top">Java Class</td>
          <td><div id="javaClass"></div></td>
        </tr>
        <tr>
          <td valign="top">Object</td>
          <td><div id="obj"></div></td>
        </tr>
      </table>
    </div>
  </fieldset>
</p>

</td></tr></table>
<hr/>

Exception Handling.
<p>
  <input type="button" value="Get Error Msg" onclick="clickErrMsg()" />
  <fieldset>
    <legend>Exception Details</legend>
    <div style="height:8em;overflow:auto">
      <table border="0" width="100%">
        <tr>
          <td valign="top">e.name</td>
          <td><div id="eName"></div></td>
        </tr>
        <tr>
          <td valign="top">e.code</td>
          <td><div id="eCode"></div></td>
        </tr>
        <tr>
          <td valign="top">e.message</td>
          <td><div id="eMsg"></div></td>
        </tr>
        <tr>
          <td valign="top">e.javaStack</td>
          <td><div id="eStack"></div></td>
        </tr>
      </table>
    </div>
  </fieldset>
</p>

</body>

</html>

